#include "modelo.h"


float walking_angles[2][6] ;
double base_move = 0.0 ;

int rotate    = 0 ;
int rotateLeg = 0 ;
int rotateCannon = -90 ;
int frame = SOLID;
int rotateV = 0;
int atirou = 2;

int zoom_flag = GL_FALSE , rotate_flag = GL_FALSE , mudaDirecaoEsquerda = GL_FALSE , mudaDirecaoDireita = GL_FALSE;


/*GLfloat LightAmbient[]= { 0.5f, 0.5f, 0.5f, 1.0f };                             // Ambient Light Values 
GLfloat LightPosition[]= { 0.0f, 0.0f, 0.0f, 0.0f };                             // Light Position 
GLfloat LightDiffuse[]= { 1.0f, 1.0f, 1.0f, 1.0f };                              // Diffuse Light Values 
GLfloat	emissiveLight[] = { 0.0f, 0.0f, 0.0f, 1.0};

GLuint	texture[1];                             // Storage For One Texture */

float langle_count = 30 ,
      langle_count2 = 0 ,
      rangle_count = -30 ,
      rangle_count2 = 0 ,
      zoom = 0.0       ;

void Draw_Floor ()
{
	/*glPushMatrix() ;
	glColor3f(0.5,0.5,0.5) ;
    glPushMatrix() ;
    glScalef(4.0,0.0,0.0) ;
    glutSolidCube(1.0) ;
    glPopMatrix() ;
    glPushMatrix() ;
    glTranslatef(0.0,-1.5,0.0) ;
    glScalef(4.0,0.0,4.0) ;
    glutWireCube(1.0) ;
    glPopMatrix() ;
    glPopMatrix() ;
	/*glPushMatrix();
	    glTranslatef(0.4,-0.2,2.5);
		glColor3f(0.5,0.5,0.5) ;
		glBegin(GL_QUADS);
			/*glTexCoord2f(1.0f, 1.0f); glVertex3f(-2.0f, -1.0f, -2.0f);
			/*glTexCoord2f(0.0f, 1.0f); glVertex3f( 2.0f, -1.0f, -2.0f);
			/*glTexCoord2f(0.0f, 0.0f); glVertex3f( 2.0f, -1.0f,  2.0f);
			/*glTexCoord2f(1.0f, 0.0f); glVertex3f(-2.0f, -1.0f,  2.0f);
		glEnd();
	glPopMatrix();*/
}

void keyboard (unsigned char key, int x, int y)
{
	switch(key)
   {
      case 's' :
         animate_base() ;
         break ;
      case 'S' :
         glutIdleFunc(animate_base) ;
         break ;
      case 'd' :
         rotate_flag = !rotate_flag ;
         break ;
      case 'D' :
         zoom_flag = !zoom_flag ;
         break ;
	  case ',' :
		 rotateLeg = (rotateLeg + 5) % 360 ;
		 glutPostRedisplay() ;
		 break ;
      case '.' :
		 rotateLeg = (rotateLeg - 5) % 360 ;
		 glutPostRedisplay() ;
		 break ;
	  case 'z' :
		 rotateCannon = (rotateCannon + 5) % 360 ;
		 glutPostRedisplay() ;
		 break ;
      case 'x' :
		 rotateCannon = (rotateCannon - 5) % 360 ;
		 glutPostRedisplay() ;
		 break ;
	  case '1' :
		 frame = WIRE ;
		 glutPostRedisplay() ;
		 break ;
	  case '2' :
		 frame = SOLID ;
		 glutPostRedisplay() ;
		 break ;
	  case '=' :
         zoom += 1 ;
         glutPostRedisplay() ;
         break ;
      case '-' :
         zoom -= 1 ;
         glutPostRedisplay() ;
         break ;
	  case 'a' :
		 atirou = 1;
		 glutPostRedisplay() ;
         break ;	
      default :
         glutIdleFunc(NULL) ;
         break ;
   }
}


void special(int key, int x, int y)
{
	switch (key)
   {
      case GLUT_KEY_UP :
         rotateV = (rotateV + 5) % 360 ;
         glutPostRedisplay() ;
         break ;
      case GLUT_KEY_DOWN :
         rotateV = (rotateV - 5) % 360 ;
         glutPostRedisplay() ;
         break ;
      case GLUT_KEY_LEFT :
         rotate = (rotate + 5) % 360 ;
         glutPostRedisplay() ;
         break ;
      case GLUT_KEY_RIGHT :
         rotate = (rotate - 5) % 360 ;
         glutPostRedisplay() ;
         break ;
      default :
      	break ;
   }
}

//================= init () ==========================

void init(void)
{
   const GLubyte* information ;

//	glClearColor(1.0, 1.0, 1.0, 0.0) ;
	  glClearColor(0.0f, 0.0f, 0.0f, 0.0f);		// This Will Clear The Background Color To Black
   glClearDepth(1.0);				// Enables Clearing Of The Depth Buffer

//   glShadeModel(GL_FLAT) ;
   glShadeModel(GL_SMOOTH);


   information = glGetString(GL_VENDOR) ;
   printf("VENDOR : %s\n", information) ;
   information = glGetString(GL_RENDERER) ;
   printf("RENDERER : %s\n", information) ;
   information = glGetString(GL_EXTENSIONS) ;
   printf("EXTENSIONS : %s\n", information) ;
   information = glGetString(GL_VERSION) ;
   printf("VERSION : %s\n", information) ;

   walking_angles[0][3] = langle_count ;
   walking_angles[1][3] = rangle_count ;
   base_move = find_base_move(langle_count,langle_count2,rangle_count,rangle_count) ;
}

//================= display() ========================

void display(void)
{
	glClear(GL_COLOR_BUFFER_BIT) ;

   glPushMatrix() ;

   glPushMatrix() ;
   glTranslatef(0.0,0.0, zoom) ;  // tran,rot = zooming
   glRotatef(rotate,0.0,1.0,0.0) ;// rot,tran = moving
   glRotatef(rotateV,0.1,0.0,0.0) ;// rot,tran = moving
/*   glTranslatef(0.0,base_move,0.0) ;
	glPushMatrix() ;
	  
//	  mudaDirecao() ;
	  Draw_Cannon(frame);
	glPopMatrix() ;
    
	glTranslatef(0.0,-0.35,0.0) ;
   
	Draw_Base_Legs(frame) ;*/
   Draw_Floor();
   Draw_Monstrengo(frame);

   glPopMatrix() ;


   glPopMatrix() ;

   glutSwapBuffers() ;

}

//================= reshape(w,h) =====================

void reshape(int w, int h)
{
 	glViewport(0, 0, (GLsizei)w, (GLsizei)h) ;
   glMatrixMode(GL_PROJECTION) ;
   glLoadIdentity() ;
   gluPerspective(65.0, (GLfloat)w/(GLfloat)h, 1.0, 20.0) ;
   glMatrixMode(GL_MODELVIEW) ;
   glLoadIdentity() ;
  	glTranslatef(0.0, 0.0, -5.0) ;
}

// =============== main(argc,argv) ===================



int main(int argc, char** argv)
{
	glutInit(&argc, argv) ;
   glutInitDisplayMode(GLUT_DOUBLE | GLUT_RGB) ;
   glutInitWindowSize(400, 400) ;
   glutInitWindowPosition(100, 100) ;
   glutCreateWindow("Meu modelo :P") ;

   init() ;

   glutDisplayFunc(display) ;
   glutReshapeFunc(reshape) ;
   glutSpecialFunc(special) ;
   glutKeyboardFunc(keyboard) ;
   glutIdleFunc(animate_base) ;
   glutMainLoop() ;

   return 0 ;
}
